#!/usr/bin/ruby -Ks
#
require '/opt/yklook/swing'
require '/opt/yklook/swingtable'
require '/opt/yklook/swingtabpane'

class MemoFile < YKLookMain

	def yki_size()
		return [640, 420]
	end

	def yki_title()
		return 'ڂ'
	end

	def yki_make_display()
		basePan        = YKLookPanelFlow.new()
		newPan         = YKLookPanelGridBag.new()
		lisPan         = YKLookPanelGridBag.new()
		edtPan         = YKLookPanelGridBag.new()
		cbxNewCategory = YKLookComboBox.new()
		cbxEdtCategory = YKLookComboBox.new()
		txtNewTitle    = YKLookTextField.new()
		txtEdtTitle    = YKLookTextField.new()
		txtNewMemo     = YKLookTextArea.new()
		txtEdtMemo     = YKLookTextArea.new()
		btnNewAppend   = YKLookButton.new( "VKo^" )
		btnEdtUpdate   = YKLookButton.new( "㏑XV" )
		btnEdtAppend   = YKLookButton.new( "VKo^" )
		tblLisList     = YKLookTable.new( ["JeS", "薼", "XVt"] )

		cbxNewCategory.yk_set_tag( 'newCbx' )
		cbxEdtCategory.yk_set_tag( 'edtCbx' )
		txtNewTitle   .yk_set_tag( 'newTf'  )
		txtEdtTitle   .yk_set_tag( 'edtTf'  )
		txtNewMemo    .yk_set_tag( 'newTa'  )
		txtEdtMemo    .yk_set_tag( 'edtTa'  )
		tblLisList    .yk_set_tag( 'table'  )

		txtNewMemo.yk_set_preferred_size( 500, 260 )
		txtEdtMemo.yk_set_preferred_size( 500, 260 )
		tblLisList.yk_set_preferred_size( 500, 280 )

		newPan.yk_add( YKLookLabel.new( "JeSG" ), [0,0,1,1],'B',nil,'NE')
		newPan.yk_add( cbxNewCategory               , [1,0,6,1],'B',nil,'N' )
		newPan.yk_add( YKLookLabel.new( "薼F"    ), [0,1,1,1],'N',nil,'NE')
		newPan.yk_add( txtNewTitle                  , [1,1,6,1],'B',nil,'N' )
		newPan.yk_add( YKLookLabel.new( "eF"    ), [0,2,1,1],'N',nil,'NE')
		newPan.yk_add( YKLookLabel.new( ""         ), [0,3,1,4],'B',nil,'N' )
		newPan.yk_add( txtNewMemo                   , [1,2,6,5],'B',nil,'N' )
		newPan.yk_add( YKLookLabel.new( ""         ), [0,7,7,1],'B',nil,'N' )
		newPan.yk_add( YKLookLabel.new( ""         ), [0,8,6,1],'B',nil,'N' )
		newPan.yk_add( btnNewAppend                 , [6,8,1,1],'N',nil,'N' )

		edtPan.yk_add( YKLookLabel.new( "JeSG" ), [0,0,1,1],'B',nil,'NE')
		edtPan.yk_add( cbxEdtCategory               , [1,0,6,1],'B',nil,'N' )
		edtPan.yk_add( YKLookLabel.new( "薼F"    ), [0,1,1,1],'N',nil,'NE')
		edtPan.yk_add( txtEdtTitle                  , [1,1,6,1],'B',nil,'N' )
		edtPan.yk_add( YKLookLabel.new( "eF"    ), [0,2,1,1],'N',nil,'NE')
		edtPan.yk_add( YKLookLabel.new( ""         ), [0,3,1,4],'B',nil,'N' )
		edtPan.yk_add( txtEdtMemo                   , [1,2,6,5],'B',nil,'N' )
		edtPan.yk_add( YKLookLabel.new( ""         ), [0,7,7,1],'B',nil,'N' )
		edtPan.yk_add( YKLookLabel.new( ""         ), [0,8,4,1],'B',nil,'N' )
		edtPan.yk_add( btnEdtUpdate                 , [4,8,1,1],'N',nil,'N' )
		edtPan.yk_add( YKLookLabel.new( ""         ), [5,8,1,1],'B',nil,'N' )
		edtPan.yk_add( btnEdtAppend                 , [6,8,1,1],'N',nil,'N' )

		lisPan.yk_add( tblLisList                   , [0,0,1,1],'B',nil,'N' )

		tab = YKLookTabPane.new().yk_set_tag( 'tab' )
		tab.yk_add( newPan, 'VK' )
		tab.yk_add( lisPan, 'ꗗ' )
		tab.yk_add( edtPan, 'ҏW' )
		tab.yk_set_selected_index( 0 )
		tab.yk_set_enabled_at( 2, false )

		basePan.yk_add( tab )
		yk_add( basePan )

		txtNewMemo.yk_set_editable( true );
		txtNewMemo.yk_set_wrap_style_word( false );

		txtEdtMemo.yk_set_editable( true );
		txtEdtMemo.yk_set_wrap_style_word( false );

		tblLisList  .yk_set_listener( :fn_table_clicked )
		btnNewAppend.yk_set_listener( :fn_new_append    )
		btnEdtUpdate.yk_set_listener( :fn_edt_update    )
		btnEdtAppend.yk_set_listener( :fn_edt_append    )

		fn_set_first_contents()
		yk_var( '@contentslist' )
		yk_var( '@contentsindex' )
	end
	def fn_nowdate()
		return Time.now().strftime('%Y-%m-%d %H:%M:%S')
	end
	def fn_set_first_contents()
		itemdata = []
		cat = []
		ary = []
		now = fn_nowdate()
		f = File.open('initial-contents.txt')
		while buf = f.gets()
			str = buf.chomp()
			if str.size() < 1
				next
			end
			contents = [ str ]
			buf = f.gets()
			if buf.nil?()
				break
			end
			contents << buf.chomp()
			contents << now
			wrk = []
			while buf = f.gets()
				if buf.index( '--[YKLook]--end-of-data--' ) == 0
					break
				end
				wrk << buf
			end
			contents << wrk.join()
			ary << contents

			if not cat.include?( contents[0] )
				cat << contents[0]
			end
			itemdata << [ contents[0], contents[1], now ]
		end
		yk_look( 'newCbx' ).yk_set_item( cat )
		yk_look( 'edtCbx' ).yk_set_item( cat )
		yk_look( 'table'  ).yk_set_item_data( itemdata )
		@contentslist = ary
	end
	def fn_table_clicked( prm_event )
		ary = @contentslist
		cbx = yk_look( 'edtCbx' )
		tf  = yk_look( 'edtTf'  )
		ta  = yk_look( 'edtTa'  )
		tab = yk_look( 'tab'    )
		tbl = yk_look( 'table'  )
		row = tbl.yk_selected_row()
		if row.size() == 1 and row[0] < ary.size()
			@contentsindex = row[0]
			contents = ary[ row[0] ]
			cbx.yk_set_selected_item( contents[0] )
			tf.yk_set_text( contents[1] )
			ta.yk_set_text( contents[3] )
			tab.yk_set_enabled_at( 2, true )
			tab.yk_set_selected_index( 2 )
		end
	end
	def fn_new_append( prm_event )
		fn_any_append( 'new' )
	end
	def fn_edt_update( prm_event )
		ary = @contentslist
		idx = @contentsindex
		if idx.nil?() or idx < 0 or ary.size() <= idx
			return
		end
		ary.delete_at( idx )
		yk_look( 'table' ).yk_remove_at_row( idx )
		fn_any_append( 'edt' )
	end
	def fn_edt_append( prm_event )
		fn_any_append( 'edt' )
	end
	def fn_any_append( prm_key )
		ary = @contentslist
		tbl = yk_look( 'table' )
		cbx = yk_look( prm_key + 'Cbx' )
		tf  = yk_look( prm_key + 'Tf'  )
		ta  = yk_look( prm_key + 'Ta'  )
		contents = [ cbx.yk_selected_item() ]
		contents << tf.yk_text()
		contents << fn_nowdate()
		contents << ta.yk_text()
		ary[0,0] = [ contents ]
		tbl.yk_add_item_data( 0, [ contents[0], contents[1], contents[2] ] )
		@contentsindex = 0
		nc = yk_look( 'newCbx' )
		ec = yk_look( 'edtCbx' )
		nc.yk_remove_at_item( contents[0] )
		ec.yk_remove_at_item( contents[0] )
		nc.yk_add_item( contents[0] )
		ec.yk_add_item( contents[0] )
		yk_show_dialog_message( nil, "o^܂" )
	end

	##def yki_laf_is_system()
	##	return false
	##end
	# def yki_fr_need_pack()
	#	return true
	# end
	# def yki_ht_farpath()
	#	return [ '/tools' , nil ]
	# end
end

YKLookMain.yk_mainloop( MemoFile.new() )

#
# end of program
